﻿using System;

namespace PoCFluentInterfaceOnDomains
{
    class Program
    {
        static void Main(string[] args)
        {
            var category = new Category();

            category.Categorize(item =>item.Named("iPhone")
                .ManufacturedBy(manufacturer =>
                    manufacturer.Named("Apple"))
                    .ForProduct(product =>
                        product.Numbered("AA1687")));

            Action<CatalogItemBuilder> a = (item => item.Named("N65")
              .ManufacturedBy(manufacturer =>
                  manufacturer.Named("Nokia"))
                  .ForProduct(product =>
                      product.Numbered("N6513")));
            category.Categorize(a);

            Func<CatalogItemBuilder, CatalogItemBuilder> f = (item => item.Named("W610")
               .ManufacturedBy(manufacturer =>
                   manufacturer.Named("Sony"))
                   .ForProduct(product =>
                       product.Numbered("W610xyz")));
            var catalogItem = f(new CatalogItemBuilder());
            category.Categorize(catalogItem);

            Func<CatalogItemBuilder, CatalogItemBuilder> f2 = (item => item.Named("MotoBlah")
               .ManufacturedBy(manufacturer =>
                   manufacturer.Named("Motorola"))
                   .ForProduct(product =>
                       product.Numbered("Meh")));
            CatalogItem catalogItem2 = f2(new CatalogItemBuilder());
            category.Categorize(catalogItem2);

            var item1 = new CatalogItemBuilder()
                .Named("iPhone")
                .Build();
            category.Categorize(item1);

            var item2 = new CatalogItemBuilder()
                .Named("iPhone")
                .ManufacturedBy(m => m.Named("Apple"))
                .Build();
            category.Categorize(item2);

            var item3 = new CatalogItemBuilder()
                 .Named("iPhone")
                 .ManufacturedBy(m => m.Named("Apple"))
                 .ForProduct(p => p.Number = "AA1687")
                 .Build();
            category.Categorize(item3);
            
            Console.ReadKey();
        }

        void Teste()
        {
            var product = new ProductBuilder().Numbered("AA1687").Build();
        }


    }
}
